//============================================================================
//	epf130es.v
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//	V1.01 Date 2000 4/26
//
//	tab stops is 2
//============================================================================
module epf130es(
	Init_Done,
	nWs,
	nRs,
	nCs,
	Cs,
	RdynBsy,
	ClkUsr,
	Data,
	DedicatedInputPins,
	DedicatedClockPins,
	Dev_Oe,
	nDev_Clr,
	Useri,
	nDack0,
	nDreq0,
	nBtermo,
	Usero,
	nNb,
	nLserr,
	Breqo,
	nS0,
	nLreseto,
	nDmapaf,
	nLlocko,
	nWaiti,
	nBreq,
	Ldshold,
	nEot0,
	Lhold,
	nLholda,
	nBlast,
	nAds,
	nLlock,
	nLinti,
	nLreseti,
	nWaito,
	nReadyo,
	nReadyi,
	nBterm,
	nDen,
	nLbe,
	nDt_r,
	nLw_r,
	Epm1_,
	Epm2_,
	Mem,
	Cn1x,
	Cn4or5_e,
	Cn1_,
	Ld,
	La,
//Ioa,
//Iob,
	Ioc,
	Iod1_,
	Iod2_
);
//============================================================================
// PLX 
//============================================================================
output nLholda;
output nLlock;
output nLinti;
output nLreseti;
output nReadyi;
output nBterm;
output nDreq0;
output nS0;
output nNb;
output nWaiti;
output nBreq;
output nEot0;
output Useri;
output nBlast;
output nAds;
output nWaito;
output nReadyo;
output nDen;
output nDt_r;
output nLw_r;
output nDack0;
output nBtermo;
output nLserr;
output Breqo;
output nLreseto;
output nDmapaf;
output nLlocko;
output Ldshold;
output Lhold;
output Usero;
output [31:0] Ld;
output [16:2] La;
output [3:0] nLbe;
//============================================================================
// EPF10K Configuring
//============================================================================
input Init_Done;	// User Mode I/O
input nWs;				// User Mode I/O
input nRs;				// User Mode I/O
input nCs;				// User Mode I/O
input Cs;					// User Mode I/O
input RdynBsy;		// User Mode I/O
input ClkUsr;			// User Mode I/O
input Dev_Oe;			// User Mode I/O
input nDev_Clr;		// User Mode I/O
input [7:1] Data;	// User Mode I/O

input [3:0] DedicatedInputPins;
input [1:0] DedicatedClockPins;
//============================================================================
//
//============================================================================
output [39:1] Mem;
input  [45:1]  Cn1_;		// IOE1~45 (Gloup E)
output [45:1]  Cn1x;		// IOE91~98,IOD16~52 (Gloup D/E)
input  [45:1]  Cn4or5_e;// IOE46~90 (Gloup E)
//input  [57:1]	 Ioa;			// IOA1~57 (Gloup A)
//input  [44:1]	 Iob;			// IOB1~44 (Gloup B)
input  [31:1]  Ioc;			// IOC1~31 (Gloup C)
input  [15:1]  Iod1_;		// IOD1~15 (Gloup D)
input  [84:53] Iod2_;  	// IOD53~84 (Gloup D)
output [8:1]   Epm1_;
input  [14:9]  Epm2_;
//============================================================================
// Not Used Pin
//============================================================================
wire Dummy = 0;
assign nLholda		= (!Dummy) ? 1'bz : 0;
assign nLlock			= (!Dummy) ? 1'bz : 0;
assign nLinti			= (!Dummy) ? 1'bz : 0;
assign nLreseti		= (!Dummy) ? 1'bz : 0;
assign nReadyi		= (!Dummy) ? 1'bz : 0;
assign nBterm			= (!Dummy) ? 1'bz : 0;
assign nDreq0			= (!Dummy) ? 1'bz : 0;
assign nS0				= (!Dummy) ? 1'bz : 0;
assign nNb				= (!Dummy) ? 1'bz : 0;
assign nWaiti			= (!Dummy) ? 1'bz : 0;
assign nBreq			= (!Dummy) ? 1'bz : 0;
assign nEot0			= (!Dummy) ? 1'bz : 0;
assign Useri			= (!Dummy) ? 1'bz : 0;
assign nBlast			= (!Dummy) ? 1'bz : 0;
assign nAds				= (!Dummy) ? 1'bz : 0;
assign nWaito			= (!Dummy) ? 1'bz : 0;
assign nReadyo		= (!Dummy) ? 1'bz : 0;
assign nDen				= (!Dummy) ? 1'bz : 0;
assign nDt_r			= (!Dummy) ? 1'bz : 0;
assign nLw_r			= (!Dummy) ? 1'bz : 0;
assign nDack0			= (!Dummy) ? 1'bz : 0;
assign nBtermo		= (!Dummy) ? 1'bz : 0;
assign nLserr			= (!Dummy) ? 1'bz : 0;
assign Breqo			= (!Dummy) ? 1'bz : 0;
assign nLreseto		= (!Dummy) ? 1'bz : 0;
assign nDmapaf		= (!Dummy) ? 1'bz : 0;
assign nLlocko		= (!Dummy) ? 1'bz : 0;
assign Ldshold		= (!Dummy) ? 1'bz : 0;
assign Lhold			= (!Dummy) ? 1'bz : 0;
assign Usero			= (!Dummy) ? 1'bz : 0;
assign Ld					= (!Dummy) ? 32'bz : 0;
assign La 				= (!Dummy) ? 15'bz : 0;
assign nLbe 			= (!Dummy) ? 4'bz : 0;
//============================================================================
// assign
//============================================================================
assign Mem   = (!Dummy) ? 39'bz : 39'b0;
//============================================================================
// assign EPF10K
//============================================================================
wire [6:1] Dedi = {DedicatedInputPins,DedicatedClockPins};
wire [16:1] Epf10kConf = {nWs,nRs,RdynBsy,nCs,Cs,ClkUsr,Data[7:1],Init_Done,Dev_Oe,nDev_Clr};
//============================================================================
function [7:0] InputData;
//============================================================================
input [6:1] Epm;
//input [57:1]	Ioa;
//input [44:1]	Iob;
input [31:1]  Ioc;
input [15:1]  Iod1_;
input [84:53] Iod2_;
input [45:1]	Cn1_;
input [45:1]	Cn4or5_e;
input [16:1]	Epf10kConf;
input [6:1]   Dedi;

begin
	case (Epm)
/*
	6'h01: InputData = Ioa[8:1];
	6'h02: InputData = Ioa[16:9];
	6'h03: InputData = Ioa[24:17];
	6'h04: InputData = Ioa[32:25];
	6'h05: InputData = Ioa[40:33];
	6'h06: InputData = Ioa[48:41];
	6'h07: InputData = Ioa[56:49];
	6'h08: InputData = {7'b0,Ioa[57]};

	6'h09: InputData = Iob[8:1];
	6'h0a: InputData = Iob[16:9];
	6'h0b: InputData = Iob[24:17];
	6'h0c: InputData = Iob[32:25];
	6'h0d: InputData = Iob[40:33];
	6'h0e: InputData = {4'b0,Iob[44:41]};
*/
	6'h0f: InputData = Ioc[8:1];
	6'h10: InputData = Ioc[16:9];
	6'h11: InputData = Ioc[24:17];
	6'h12: InputData = {1'b0,Ioc[31:25]};

	6'h13: InputData = Iod1_[8:1];
	6'h14: InputData = {1'b0,Iod1_[15:9]};

	6'h15: InputData = Iod2_[60:53];
	6'h16: InputData = Iod2_[68:61];
	6'h17: InputData = Iod2_[76:69];
	6'h18: InputData = Iod2_[84:77];

	6'h19: InputData = Cn1_[8:1];
	6'h1a: InputData = Cn1_[16:9];
	6'h1b: InputData = Cn1_[24:17];
	6'h1c: InputData = Cn1_[32:25];
	6'h1d: InputData = Cn1_[40:33];
	6'h1e: InputData = {3'b000,Cn1_[45:41]};

	6'h1f: InputData = Cn4or5_e[8:1];
	6'h20: InputData = Cn4or5_e[16:9];
	6'h21: InputData = Cn4or5_e[24:17];
	6'h22: InputData = Cn4or5_e[32:25];
	6'h23: InputData = Cn4or5_e[40:33];
	6'h24: InputData = {3'b000,Cn4or5_e[45:41]};

	6'h3c: InputData = Epf10kConf[8:1];		// OMAKE
	6'h3e: InputData = Epf10kConf[16:9];	// OMAKE
	6'h3f: InputData = Dedi[6:1];					// OMAKE

	default:InputData = 0;
	endcase
end
endfunction
//============================================================================
// assign
//============================================================================

assign Epm1_[8:1] = InputData(
		Epm2_,
//	Ioa,
//	Iob,
		Ioc,
		Iod1_,
		Iod2_,
		Cn1_,
		Cn4or5_e,
		Epf10kConf,
		Dedi
);

assign Cn1x = Cn1_;

endmodule

