//==========================================================================
//	epm7064.v
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//	V1.01 Date 2000/06/08
//
//	tab stops is 2
//============================================================================
module epm7064(
	nLholda,
	nBlast,
	nAds,
	nLlock,
	nLinti,
	nLreseti,
	nWaito,
	nReadyo,
	Lclk,
	nReadyi,
	nBterm,
	nDen,
	nLbe,
	nDt_r,
	nLw_r,
	La,
	ReadData,
	WriteData,
	Tdo,
	nGClr7256,
	nOe17256,
	Ld,
	nDack0,
	nDreq0,
	nBtermo,
	nS0,
	nNb,
	Mclk,
	nLserr,
	Breqo,
	LclkIn,
	nLreseto,
	nDmapaf,
	nLlocko,
	nWaiti,
	nBreq,
	Ldshold,
	nEot0,
	Lhold,
);
//============================================================================
//
//============================================================================
output [2:0] WriteData;
output Lclk;			// Local Clock 30MHz
output nGClr7256;
output nOe17256;

input nLholda;		// Hold Acknowledge
input nBlast;			// Burst Last
input nAds;				// Address Strobe
input nLlock;			// Bus Lock
input nLinti;			// Local Interrupt In
input nLreseti;		// Local Reset Input
input nWaito;			// Wait Out
input nReadyo;		// Ready Out
input nReadyi;		// Ready In
input nBterm;			// Burst Terminate
input nDen;				// Data Enable
input [3:0] nLbe;	// Byte Enables
input nDt_r;			// Data Transmit/Receive
input nLw_r;			// Write/Read
input [16:3] La;	// AddressBus16~3
input ReadData;
input Tdo;

input [7:0] Ld;		// DataBus7~0
input nDack0;			// DMA Acknowledge output
input nDreq0;			// DMA Request output
input nBtermo;		// Burst Terminate output
input nS0;				// Address Select 0
input nNb;				// No Local Bus Initialzation
input nLreseto;		// Local Bus Reset Out
input nDmapaf;		// Direct Master Programmable Almost Full
input nLlocko;		// Bus Lock
input nWaiti;			// Wait Input
input nBreq;			// Bus Request
input Ldshold;		// Direct Slave HOLD Request
input nEot0;			// End of Transfer
input Lhold;			// Hold Request

input  nLserr;		// System Error Interrupt Output
input  Breqo;			// Bus Request Out
input  LclkIn;		// Lclk Input

input  Mclk;			// Master Clock 60MHz
//============================================================================
//
//============================================================================
assign WriteData	= 3'b111;
/*
wire Dummy = 0;
assign nLholda		= (!Dummy) ? 1'bz : 1'b0;
assign nBlast			= (!Dummy) ? 1'bz : 1'b0;
assign nAds				= (!Dummy) ? 1'bz : 1'b0;
assign nLlock			= (!Dummy) ? 1'bz : 1'b0;
assign nLinti			= (!Dummy) ? 1'bz : 1'b0;
assign nLreseti		= (!Dummy) ? 1'bz : 1'b0;
assign nWaito			= (!Dummy) ? 1'bz : 1'b0;
assign nReadyo		= (!Dummy) ? 1'bz : 1'b0;
assign nReadyi		= (!Dummy) ? 1'bz : 1'b0;
assign nBterm			= (!Dummy) ? 1'bz : 1'b0;
assign nDen				= (!Dummy) ? 1'bz : 1'b0;
assign nLbe				= (!Dummy) ? 4'bz : 4'b0;
assign nDt_r			= (!Dummy) ? 1'bz : 1'b0;
assign nLw_r			= (!Dummy) ? 1'bz : 1'b0;
assign La					= (!Dummy) ? 14'bz : 14'b0;
assign ReadData		= (!Dummy) ? 1'bz : 1'b0;
assign Tdo				= (!Dummy) ? 1'bz : 1'b0;
assign Ld					= (!Dummy) ? 8'bz : 8'b0;
assign nDack0			= (!Dummy) ? 1'bz : 1'b0;
assign nDreq0			= (!Dummy) ? 1'bz : 1'b0;
assign nBtermo		= (!Dummy) ? 1'bz : 1'b0;
assign nS0				= (!Dummy) ? 1'bz : 1'b0;
assign nNb				= (!Dummy) ? 1'bz : 1'b0;
assign nLreseto		= (!Dummy) ? 1'bz : 1'b0;
assign nDmapaf		= (!Dummy) ? 1'bz : 1'b0;
assign nLlocko		= (!Dummy) ? 1'bz : 1'b0;
assign nWaiti			= (!Dummy) ? 1'bz : 1'b0;
assign nBreq			= (!Dummy) ? 1'bz : 1'b0;
assign Ldshold		= (!Dummy) ? 1'bz : 1'b0;
assign nEot0			= (!Dummy) ? 1'bz : 1'b0;
assign Lhold			= (!Dummy) ? 1'bz : 1'b0;
*/
//============================================================================
//
//============================================================================
assign nOe17256 = 1;
assign nGClr7256 = 1;

reg Lclk;
//============================================================================
always @(posedge Mclk) begin
//============================================================================
	Lclk <= ~Lclk;
end

endmodule
