//===================================================================
// 8284ppa.c
//-------------------------------------------------------------------
// ̃\[XɂPPA[hł̃RtBO[V̎gpႪLq
// ܂
//
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//===================================================================
#define	STRICT
#include <windows.h>
#include <tchar.h>
#include "Apci8284w.h"

#define	A1				1
#define	C2				2
#define	D2				3

//#define _BORD_NUMBER		A1
//#define _BORD_NUMBER		C2
#define _BORD_NUMBER		D2

#if _BORD_NUMBER == D2
#define FILENAME_1		"epf2ppap.rbf"	//aPCI-8284D2 Primary
#define FILENAME_2		"epf2ppas.rbf"	//aPCI-8284D2 Secondary
#elif _BORD_NUMBER == C2
#define FILENAME_1		"epf3ppap.rbf"	//aPCI-8284C2 Primary
#define FILENAME_2		"epf3ppas.rbf"	//aPCI-8284C2 Secondary
#elif _BORD_NUMBER == A1
#define FILENAME_1		"epf5ppap.rbf"	//aPCI-8284A1 Primary
#define FILENAME_2		"epf5ppas.rbf"	//aPCI-8284A1 Secondary
#endif

#define ADDRP0			0x0
#define ADDRP1			0x1
#define ADDRP2			0x10
#define ADDRS0			0x8
#define ADDRS1			0x9
#define ADDRS2			0x11

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);
static BOOL PpaInit(BOOL bPrimary);
static BOOL PpaTrans(BOOL bPrimary, BYTE bBuff);
static BOOL PpaFinish(BOOL bPrimary);
static BOOL PpaCheck(BOOL bPrimary);

BOOL	OnCreate( HWND hWnd );
BOOL	OnDestroy( void );
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

WORD	wLogSlot;
TCHAR	szbuf[2048];
char	szClassName[] = "oo`TvvO";
//===================================================================
// C
//===================================================================
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
										LPSTR lpCmdLine, int nCmdShow)
{
	MSG			msg;
	WNDCLASS	wc;
	HWND		hWnd;
	//---------------------------------------------------------------
	// EChENXo^
	//---------------------------------------------------------------
	if (!hPrevInstance) {
		wc.style			= CS_HREDRAW | CS_VREDRAW;
		wc.lpfnWndProc		= WndProc;
		wc.cbClsExtra		= 0;
		wc.cbWndExtra		= 0;
		wc.hInstance		= hInstance;
		wc.hIcon			= NULL;
		wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
		wc.hbrBackground	= GetStockObject(WHITE_BRUSH);
		wc.lpszMenuName		= NULL;
		wc.lpszClassName	= szClassName;
		if (!RegisterClass(&wc)) return FALSE;
	}
	//---------------------------------------------------------------
	// EChE쐬
	//---------------------------------------------------------------
	hWnd = CreateWindow(szClassName,
		"aPCI-8284",
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		NULL,
		NULL,
		hInstance,
		NULL);

	if ( hWnd == NULL ) return FALSE;
	//---------------------------------------------------------------
	// EChE\
	//---------------------------------------------------------------
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	//---------------------------------------------------------------
	// bZ[W[v
	//---------------------------------------------------------------
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return (msg.wParam);
}
//===================================================================
// EChEbZ[W
//===================================================================
LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg) {

		case WM_SHOWWINDOW:
			if ( OnCreate(hWnd) == FALSE)
				MessageBox(NULL, "PPA Failed", "aPCI-8284", MB_OK | MB_ICONSTOP);
			else
				MessageBox(NULL, "PPA Completed", "aPCI-8284", MB_OK | MB_ICONINFORMATION);
			break;

		case WM_DESTROY:
			OnDestroy();
			PostQuitMessage(0);
			break;

		default:
			return(DefWindowProc(hWnd, msg, wParam, lParam));
	}
	return 0;
}
//===================================================================
// obt@ckkJ
//===================================================================
BOOL OnDestroy( void )
{
	//---------------------------------------------------------------
	// foCX̎gpI
	//---------------------------------------------------------------
	if ( Apci8284wClose(wLogSlot) == FALSE ) {
		ErrorMessage(APCI8284_SLOT_AUTO);
		return FALSE;
	}
	wsprintf(szbuf, _T("foCX̎gpI\n\n")
					_T("LogSlot: %2d") ,
					wLogSlot);
	ResultMessage(szbuf);
	//---------------------------------------------------------------
	// DLL̃A[h
	//---------------------------------------------------------------
  	Apci8284wDllClose();

	return TRUE;
}
//===================================================================
// ckk[hoo`I܂ł̏
//===================================================================
BOOL OnCreate( HWND hWnd )
{
	DWORD	i;
	BOOL	bPrimary = FALSE;
	HANDLE	FileHandle = INVALID_HANDLE_VALUE;
	PBYTE	pbBuff;
	DWORD	NumberOfBytesRead;
	DWORD	dwFileLen;
	TCHAR	szFileName[256];

	//---------------------------------------------------------------
	// DLL̎gp錾
	//---------------------------------------------------------------
	if ( Apci8284wDllOpen() == FALSE ) {
		ErrorMessage(APCI8284_SLOT_AUTO);
		return FALSE;
	}
	//---------------------------------------------------------------
	// foCX̎gp錾
	//---------------------------------------------------------------
	wLogSlot = APCI8284_SLOT_AUTO;
	if ( Apci8284wCreate( &wLogSlot, NULL, 0 ) == FALSE ) {
		ErrorMessage(APCI8284_SLOT_AUTO);
		return FALSE;
	}
	wsprintf(szbuf, _T("foCX̎gp錾\n\n")
					_T("LogSlot: %2d"), wLogSlot);
	ResultMessage(szbuf);
	//---------------------------------------------------------------
	// oo`sfoCX̑I
	//---------------------------------------------------------------
	if ( MessageBox(NULL, "Yes is Primary , No is Secondary",
						  "aPCI-8284",
						  MB_YESNO | MB_ICONQUESTION | MB_DEFBUTTON1) == IDYES )
		bPrimary = TRUE;
	//---------------------------------------------------------------
	// oo`O
	//---------------------------------------------------------------
	if ( PpaInit(bPrimary) == FALSE ) return FALSE;
	//---------------------------------------------------------------
	// t@C̃I[v
	//---------------------------------------------------------------
	if ( bPrimary == TRUE ) wsprintf( szFileName, "%s", FILENAME_1 );
	else					wsprintf( szFileName, "%s", FILENAME_2 );

	FileHandle = CreateFile(
		szFileName,							// t@C
		GENERIC_READ,						// ANZX
		0,									// t@CL@
		NULL,								// ZLeBLqq̃AhX
		OPEN_EXISTING,						// 쐬@
		FILE_ATTRIBUTE_NORMAL,				// t@C,
		NULL );								// Rs[鑮tt@C̃nh	

	if ( FileHandle == INVALID_HANDLE_VALUE ) return FALSE;
	//---------------------------------------------------------------
	// t@CTCY̎擾
	//---------------------------------------------------------------
	dwFileLen = _llseek((HFILE)FileHandle,0,FILE_END);
	if ( !dwFileLen ) return FALSE;
	//---------------------------------------------------------------
	// t@CTCYm
	//---------------------------------------------------------------
	pbBuff = (PBYTE)malloc( dwFileLen );
	if ( pbBuff == NULL ) return FALSE;
	//---------------------------------------------------------------
	// t@C|C^0ɖ߂
	//---------------------------------------------------------------
	_llseek((HFILE)FileHandle,0,FILE_BEGIN);
	//---------------------------------------------------------------
	// t@C̓ǂݍ
	//---------------------------------------------------------------
	ReadFile(
		FileHandle,
		pbBuff,
		dwFileLen,
		&NumberOfBytesRead,
		NULL );
	//---------------------------------------------------------------
	// t@C̃N[Y
	//---------------------------------------------------------------
	CloseHandle( FileHandle );
	//---------------------------------------------------------------
	// PoCgÂ]
	//---------------------------------------------------------------
	for ( i=0 ; i<dwFileLen-1 ; i++ ) {
		if ( PpaTrans(bPrimary,pbBuff[i]) == FALSE ) return FALSE;
	}
	//---------------------------------------------------------------
	// oo`I
	//---------------------------------------------------------------
	if ( PpaFinish(bPrimary) == FALSE ) return FALSE;
	//---------------------------------------------------------------
	// oo`̌ʂ
	//---------------------------------------------------------------
	if ( PpaCheck(bPrimary) == FALSE ) return FALSE;

	return TRUE;
}
//===================================================================
// oo`O
//===================================================================
static BOOL PpaInit(BOOL bPrimary)
{
	BYTE bData;
	DWORD dwAddr0 = ( bPrimary == TRUE ) ? ADDRP0 : ADDRS0;
	DWORD dwAddr1 = ( bPrimary == TRUE ) ? ADDRP1 : ADDRS1;

	// CONFIG=0,CS=0,RS=1,WS=1
	if ( Apci8284wMemWriteByte(wLogSlot,1,dwAddr1,0x03) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}
	// STATUS=0,CONF_DONE=0,RDYnBSY=1ł邱ƂmF
	if ( Apci8284wMemReadByte(wLogSlot,1,dwAddr0,&bData) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}
	if ( (bData & 0x07) != 0x01 ) return FALSE;

	// CONFIG=1,CS=1,RS=1,WS=1
	if ( Apci8284wMemWriteByte(wLogSlot,1,dwAddr1,0x0f) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	// STATUS=1,CONF_DONE=0,RDYnBSY=1ł邱ƂmF
	if ( Apci8284wMemReadByte(wLogSlot,1,dwAddr0,&bData) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}
	if ( (bData & 0x07) != 0x05 ) return FALSE;

	return TRUE;
}
//===================================================================
// PoCgÂ]
//===================================================================
static BOOL PpaTrans(BOOL bPrimary, BYTE bBuff)
{
	int i;
	BYTE bData;
	DWORD dwAddr0 = ( bPrimary == TRUE ) ? ADDRP0 : ADDRS0;
	DWORD dwAddr1 = ( bPrimary == TRUE ) ? ADDRP1 : ADDRS1;

	// STATUS=1,CONF_DONE=0,RDYnBSY=1ł邱ƂmF
	if ( Apci8284wMemReadByte(wLogSlot,1,dwAddr0,&bData) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}
	if ( (bData & 0x07) != 0x05 ) return FALSE;

	// CONFIG=1,CS=1,RS=1,WS=1
	if ( Apci8284wMemWriteByte(wLogSlot,1,dwAddr1,0x0f) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	// DATA=Buff
	if ( Apci8284wMemWriteByte(wLogSlot,1,dwAddr0,bBuff) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	// CONFIG=1,CS=1,RS=1,WS=0
	if ( Apci8284wMemWriteByte(wLogSlot,1,dwAddr1,0x0e) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	// CONFIG=1,CS=1,RS=0,WS=1
	if ( Apci8284wMemWriteByte(wLogSlot,1,dwAddr1,0x0d) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	// DATA71ɂȂ閘҂(DATA7=BUSY)
	for ( i=0 ; i<100 ; i++) {

		if ( Apci8284wMemReadByte(wLogSlot,1,dwAddr0,&bData) == FALSE ) {
			ErrorMessage(wLogSlot);
			return FALSE;
		}
		if ( (bData & 0x08) == 0x08 ) break;
	}
	// CONFIG=1,CS=1,RS=1,WS=1
	if ( Apci8284wMemWriteByte(wLogSlot,1,dwAddr1,0x0f) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}
	if ( i==100 ) return FALSE;

	return TRUE;
}
//===================================================================
// oo`I
//===================================================================
static BOOL PpaFinish(BOOL bPrimary)
{
	BYTE bData;
	DWORD dwAddr0 = ( bPrimary == TRUE ) ? ADDRP0 : ADDRS0;
	DWORD dwAddr1 = ( bPrimary == TRUE ) ? ADDRP1 : ADDRS1;

	// STATUS=1,CONF_DONE=1,RDYnBSY=1ł邱ƂmF
	if ( Apci8284wMemReadByte(wLogSlot,1,dwAddr0,&bData) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}
	if ( (bData & 0x07) != 0x07 ) return FALSE;

	return TRUE;
}
//===================================================================
// oo`̌ʂ
//===================================================================
static BOOL PpaCheck(BOOL bPrimary)
{
	BYTE bData;

	if ( bPrimary == TRUE ) {
		// oo`ɐĂaaǂ߂
		if ( Apci8284wMemReadByte(wLogSlot,1,ADDRP2,&bData) == FALSE ) {
			ErrorMessage(wLogSlot);
			return FALSE;
		}
		if ( bData != 0xaa ) return FALSE;
	} else {
		// oo`ɐĂ2aǂ߂
		if ( Apci8284wMemReadByte(wLogSlot,1,ADDRS2,&bData) == FALSE ) {
			ErrorMessage(wLogSlot);
			return FALSE;
		}
		if ( bData != 0x2a ) return FALSE;
	}

	return TRUE;
}
//===================================================================
// ʂ\
//===================================================================
static void	ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, "aPCI-8284", MB_OK | MB_ICONINFORMATION);
}
//===================================================================
// G[bZ[W\ďI
//===================================================================
static void	ErrorMessage(WORD wLogSlot)
{
	DWORD 	dwRes = Apci8284wGetLastError(wLogSlot);
	TCHAR	szbuf[50];

	switch(dwRes) {
		case APCI8284_ERR_SYSTEM:
			wsprintf(szbuf, _T("System error\n\n")
							_T("Error code: %08lxH") , GetLastError());
			break;

		case APCI8284_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("aPCI-8284 error\n\n")
							_T("Error code: %08lxH") , dwRes);
			break;
	}
	MessageBox(NULL, szbuf, "aPCI-8284", MB_OK | MB_ICONSTOP);
	// I
	Apci8284wClose(wLogSlot);
  	Apci8284wDllClose();
}
